function [help_str]=help_imc(IMENU)

%HELP FILE
%----------------------------------------------------------------

help_str='';

%LOAD-------------------------------------

if IMENU==1200
help_str=strvcat('TO LOAD A FILE:',' ',...
'Press the space bar to see the choices',...
'for files to load. Choose a file,',...
'then click on the Load window.  Click',...
'inside the rectangular box and type in',...
'the file name.',...
'Click the OK button.');

%SAVE--------------------------------------

elseif IMENU==1300
help_str=strvcat('TO SAVE A FILE',' ',...
'The directory above the box shows',...
'where the file will be saved. To save',...
'within the listed directory, click',...
'inside the rectangular box and type in',...
'the file name.',...
'Click the OK button.');

%CHANGE DIRECTORY--------------------------

elseif IMENU==1400
help_str=strvcat('TO CHANGE DIRECTORY:',' ',...
'Click inside the rectangular box and',...
'delete the current directory name. Type',...
'in the new directory name beginning',...
'with the drive ( e.g.  a:\  b:\  or  c:\ ).',...
'Click the OK button.');

%EDIT PROCESS--------------------------

elseif IMENU==2100
help_str=strvcat('TO EDIT A PROCESS:',' ',...
'Enter an uncertain process in the ',...
'LaPlace form: ',' ',...
'                    Polynomial 1',...
'Process =  ------------------------ * exp(-T*s)',...
'                    Polynomial 2',' ',...
'The coefficients of the polynomials',...
'and the deadtime T may be constants',...
'or may vary independently within',...
'specified ranges (see uncertainty',... 
'limits).',' ',...
'Example of an uncertain process:',' ',...
'                  K(-s+1)',...
'P1 = ------------------------------------- exp(-T*s)',...
'         (Tau1*s+1)*(Tau2*s+1)',' ',...
'with uncertain gain K, time constants ',...
'Tau1 and Tau2 and deadtime T would',...
'be entered as',' ',...
'            u;-1 1',...
'P1 = ----------------- * u',...
'           u 1;u 1',' ',...
'in appropriate windows in the Process',...
'Edit screen.',' ',...
'DISTURBANCE LAG:',...
'Enter coefficients [k1 k2 k3]',...
'of an assumed second order lag',...
'a disturbance passes through.',' ',...
'		    1',...
'	Lag =  ---------------------------',...
'	            k1*s^2+k2*s+k3',' ',...
'* default = [0 0 1]',' ',...
'EDIT CORRELATED UNCERTAIN PARAMETERS:',' ',...
'The same two or more uncertain parameters',' ',...
'can be enter as u cascaded with',...
'a same number',...
'Example of an uncertain process:',' ',...
'        K(-s+1)',...
'P1 =-------------- exp(-T*s)',...
'       (Tau*s+1)',' ',...
'with uncertain gain K, time constants ',...
'Tau and deadtime T and the disturbance lag as',...
'Tau*s+1, the same Tau would be entered as',' ',...
'           u;-1 1',...
'P1 = -------------- * u',...
'           u1 1',' ',...
'in appropriate windows in the Process',...
'Edit screen.',' ',...
'Enter coefficients [u1 1]',...
'of an assumed first order lag',...
'a disturbance passes through.',' ',...
'	 1',...
'Lag =  ------------------',...
'           Tau*s+1');



%EDIT MODEL--------------------------

elseif IMENU==2200
help_str=strvcat('TO EDIT A MODEL:',' ',...
'Enter a model of an uncertain process',...
'in the LaPlace form:',' ',...
'                    Polynomial 1',...
'Model   =   ------------------------ * exp(-T*s)',...
'                    Polynomial 2',' ',...
'The coefficients of the polynomials and',...
'the deadtime T have to be constants.',... 
'Example of a model for an uncertain',...
'process:',' ',...
'                  10(-s+1)',...
'M1 = --------------------------------- exp(-5*s)',...
'           (3s+1)(s^2+.5s+1)',' ',...
'would be entered as',' ',...
'            10;-1 1',...
'M1 = --------------------- * 5',...
'           3 1;1 .5 1',' ',...
'in appropriate windows in the Model',...
'Edit screen.',' ',...
'In case of an optimal model calculation ',...
'enter the model parameters that you want ',...
'to vary as "uncertain" the same way as ',...
'the uncertain process parameters. ',' ',...
'           u',...
'M1 = ---------- * u',...
'        3 1;5 1',' ',...
'For this case, a gain and deadtime from ',...
'specified ranges will be chosen as model ',...
'parameters to satisfy an optimality ',...
'criterion (see COMPUTE section, FIND ',...
'OPTIMAL MODEL option)|');

%EDIT INV. PART OF A MODEL--------------------------

elseif IMENU==2300
help_str=strvcat('TO EDIT AN INVERTIBLE PART',...
'OF A MODEL:',' ',...
'Enter a part of a model in the LaPlace',...
'form which will be inverted and become',... 
'part of the IMC controller.',' ',...
'                     Polynomial 1',...
'Inv. part =   ------------------------',...
'                     Polynomial 2',' ',...
'The coefficients of the polynomials',...
'have to be constants.',...
'Example of an invertible part',...
'of a model:',' ',...
'                        10',...
'Inv1 = --------------------------------- ',...
'             (3s+1)(s^2+.5s+1)',' ',...
'would be entered as',' ',...
'                  10',...
'Inv1 = --------------------- ',...
'              3 1;1 .5 1',' ',...
'in appropriate windows in the Invertible',... 
'Part of a Model Edit screen. Since the',...
'realizable IMC controller is formed as',...
'             1',...
'   Q = --------- * F',...
'           Inv1 ',' ',...  
'where F is a filter',' ',...
'               1',...
'   F = -----------------',...
'          (e*s+1)^r',' ',...
'The order of a filter "r" has to be entered',...
'in the frame within the Invertible Part',...
'of the EDIT MODEL screen. The filter time',...
'constant "e" can be either entered',...
'directly in the Default Variables Edit',...
'window or can be computed by',... 
'choosing the item IMC CONTROLLER ',...
'TUNING in the COMPUTE menu.',' ',...
'In case of an optimal model calculation ',...
'enter the model parameters that you want ',...
'to vary as "uncertain" the same way as ',...
'the uncertain model parameters ',...
'(See EDIT MODEL). This is important ',...
'especially in case optimal gain of ',...
'a model is to be found.|');

%EDIT UNCERTAINTY LIMITS--------------------------

elseif IMENU==2400
help_str=strvcat('TO EDIT UNCERTAINTY LIMITS',' ',...
'Enter two vectors',...
'- upper bound of uncertain parameters',...
'- lower bound of uncertain parameters',...
'in appropriate windows.',...
'Leave a space between numbers.',' ',...
'Example:',' ',...
'Upp. bound = 11 4 6',...
'Low. bound =  9 2 4',' ',...
'In case of the uncertainty bounds ',...
'calculation enter also a nominal plant, ',...
'a vector of numbers that will be assigned ',...
'to the uncertain parameters. The uncertainty ',...
'bounds will then be calculated given ',...
'a control system and assuming the nominal ',...
'plant be mid-range parameters with the same ',...
'percentage deviations around each ',...
'parameter.',' ',...
'Example: ',' ',...
'Nominal plant = 10 3 5 |');



%EDIT MODEL RANGE LIMITS--------------------------

elseif IMENU==2500
help_str=strvcat('TO EDIT MODEL RANGE LIMITS',' ',...
'Enter three vectors',...
'- nominal model',...
'- upper bound of uncertain model parameters',...
'- lower bound of uncertain model parameters',...
'in appropriate windows.',...
'Leave a space between numbers.',' ',...
'Example:',' ',...
'Nom. model = 10 3 5',...
'Upp. bound = 11 4 6',...
'Low. bound =  9 2 4',' ',...
'Upper and lower bounds will be used only ',...
'if FIND OPTIMAL MODEL in the COMPUTE ',...
'section is chosen. The current nominal model ',...
'parameters will be used in all other ',...
'calculations.|');

%EDIT SATURATION BOUNDS--------------------------
elseif IMENU==2550
help_str=strvcat('TO EDIT SATURATION BOUNDS',' ',...
'Enter two numbers',...
'- upper bound of the saturation',...
'- lower bound of the saturation',...
'in appropriate windows.',...
'Example:',' ',...
'Upper bound = 11',' ',...
'Low. bound =  9',' ',...
'Upper and lower bounds will be used only ',...
'if IMC SATURATION STEPONSES and MSF STEP RESPONSES in RESULTS',...
'section are chosen. The current nominal model ',...
'parameters will be used in all other ',...
'calculations.|');

%EDIT DEFAULT VARIABLES--------------------------

elseif IMENU==2600
help_str=strvcat('TO EDIT DEFAULT VARIABLES',' ',...
'Enter initial values of all parameters',...
'associated with the design problem.',' ',...
'EPSILON:',...
'the filter time constant (a scalar for',... 
'1-degree-of-freedom IMC controller,',...
'a 1x2 vector for a 2-degree-of-freedom',... 
'IMC controller)',...
'* default = 0',' ',...
'MAXIMUM PEAK:',...
'the maximum peak (a scalar for',...
'1-degree-of-freedom IMC controller,',... 
'a 1x2 vector for a 2-degree-of-freedom',...
'IMC controller) of possible frequency',...
'responses over all plants within the',... 
'specified uncertainty set',...
'* default = 1.05',' ',...
'NOISE AMPLIFICATION FACTOR:',...
'a number that specifies maximum',...
'allowable amplification of noise',...
'by the IMC controller',...
'* default = 20',' ',...
'WORST CASE FREQUENCY:',...
'frequency at which the maximum peak',...
'was found',...
'* default = 0',' ',...
'FREQUENCY RANGE:',...
'a vector of two integers that specifies',...
'the range of frequencies for which the',...
'upper/lower bound of frequency',...
'responses will be computed',...
'* default = -1 1',...
'(i.e. the frequency range is',... 
'[ 10^(-1)  10^(1) ] )',' ',...
'NUMBER OF POINTS PER DECADE:',...
'for which the maximum magnitude of',...
'frequency responses will be computed',...
'* default = 10',...
'(i.e. for the above frequency range it',...
'would mean to compute 20 points for',...
'both upper and lower bound)',' ',...
'ACCURACY:',...
'A number taken as a condition to stop',...
'some algorithms when desired',...
'accuracy is achieved',...
'* default = 0.005',' ',...
'INFINITY:',...
'A number to be considered "very large"',...
'or "infinity"',...
'* default = 10^5',' ',...
'CONTROL STRUCTURE FILENAME:',...
'These are four built-in control',...
'structures:',' ',...
'imc1com -  1-degree-of-freedom',...
'complementary sensitivity function',' ',...
'imc2com -  2-degree-of-freedom',...
'complementary sensitivity function',' ',...
'imc1sen -  1-degree-of-freedom',...
'sensitivity function',' ',...
'imc2sen -  2-degree-of-freedom',...
'sensitivity function',' ',...
'imc1msf -  model state feedback',' ',...
'The user can define a control structure',...
'and save it in an accessible directory',...
'under "user1.m" or "user2.m".',... 
'The user-defined control structures',...
'can be used only for upper or lower',...
'bound of frequency responses',...
'computations not for tuning',...
'the control systems.',' ',...
'user1   -  user-defined control structure',... 
'for a 1-degree of-freedom control',...
'system (graphs shown under the',... 
'complementary sensitivity function',...
'option)',' ',...
'user2   -  user-defined control structure',...
'for a 2-degree of-freedom control',...
'system (graphs shown under the',...
'complementary sensitivity function',...
'option)',...
'* default = imc1com');


%EDIT SPECIAL PROCESS--------------------------

elseif IMENU==2710
help_str=strvcat('TO EDIT A PROCESS',' ',...
'Use this option to enter a process',...
'in case its LaPlace form cannot be',...
'entered in the standard form of',' ',...
'                    Polynomial 1',...
'Process =  ------------------------ * exp(-T*s)',...
'                    Polynomial 2',' ',...
'with independently varying uncertain',...
'parameters.',' ',...
'Example:',' ',...
'              K(1+exp(-T*s))',...
'P1 = --------------------------------------------------------',...
'        (Tau1*s+1)*(Tau2^2*s^2+Tau2*s+1)',' ',...
'would be entered as',' ',...
'P1 = x(1)*(1+exp(-x(2)*s))/(x(3)*s+1)/',...
'((x(4)*s)^2+x(4)*s+1)',' ',...
'!!! Watch the syntax !!!',' ',... 
'Any syntax error will result in stopping',...
'all routines (with a beep) when they',...
'encounter the error. If an error is',...
'detected check the entries.',' ',...
'It is up to the user to enter the',...
'correct number of uncertain parameters',...
'and their bounds. The error checking',...
'routines which work with the normal',...
'edit windows do not work with the edit',...
'special window. Also, the IMC Time',...
'Response window does not work when',...
'the process is entered through the edit',...
'special window. The PID controller',...
'calculation does not work when the',...
'model or the controller is entered',...
'through the edit special window.');

%EDIT SPECIAL MODEL--------------------------

elseif IMENU==2720
help_str=strvcat('TO EDIT A MODEL',' ',...
'Use this option to enter a model',...
'in case its LaPlace form cannot be',...
'entered in the standard form of',' ',...
'                    Polynomial 1',...
'Model   =  ------------------------ * exp(-T*s)',...
'                    Polynomial 2',' ',...
'with all coefficients of the polynomials',...
'and the deadtime T to be constants.',' ',...
'Example:',' ',...
'              10(1+exp(-5*s))',...
'M1 = ------------------------------------ ',...
'           (3s+1)*(s^2+.5s+1)',' ',...
'would be entered as',' ',...
'M1 = 10*(1+exp(-5*s))/(3*s+1)/',...
'(s^2+.5*s+1)',' ',...
'!!! Watch the syntax !!!',' ',... 
'Any syntax error will result in stopping',...
'all routines (with a beep) when they',...
'encounter the error. If an error is',...
'detected check the entries.',' ',...
'It is up to the user to enter the',...
'correct number of uncertain parameters',...
'and their bounds. The error checking',...
'routines which work with the normal',...
'edit windows do not work with the edit',...
'special window. Also, the IMC Time',...
'Response window does not work when',...
'the process is entered through the edit',...
'special window. The PID controller',...
'calculation does not work when the',...
'model or the controller is entered',...
'through the edit special window.');


%EDIT SPECIAL CONTROLLER--------------------------

elseif IMENU==2730
help_str=strvcat('TO EDIT A CONTROLLER',' ',...
'Use this option to enter an IMC',...
'controller in case its LaPlace form',...
'cannot be entered in the standard',...
'form of',' ',...
'                          1',...
'Cont. =  ------------------------------------- * Filter',...
'              Invert. part of a model',' ',...
'with all coefficients of the polynomials',...
'to be constants.',' ',...
'Example:',' ',...
'            (3s+1)*(s^2+.5s+1)',...
'C1 = --------------------------------------- ',...
'                   (es+1)^3',' ',...
'would be entered as',' ',...
'C1 = (3*s+1)*(s^2+.5*s+1)/(e*s+1)^3',' ',...
'with "e" as the filter time constant',' ',...
'!!! Watch the syntax !!!',' ',... 
'Any syntax error will result in stopping',...
'all routines (with a beep) when they',...
'encounter the error. If an error is',...
'detected check the entries.',' ',...
'It is up to the user to enter the',...
'correct number of uncertain parameters',...
'and their bounds. The error checking',...
'routines which work with the normal',...
'edit windows do not work with the edit',...
'special window. Also, the IMC Time',...
'Response window does not work when',...
'the process is entered through the edit',...
'special window. The PID controller',...
'calculation does not work when the',...
'model or the controller is entered',...
'through the edit special window.');


%VIEW PROCESS VARIABLES--------------------------

elseif IMENU==310
help_str=strvcat('TO VIEW A SYSTEM',' ',...
'View entered process, model, controller',... 
'and a disturbance lag time constant',...
'with associated time constant Alpha for',...
'the "qd" portion of 2-degree-of-freedom',...
'controller',' ',...
'           Alpha*s+1',...
'qd = ----------------------',...
'              e*s+1',' ',...
'Also, the ranges for all uncertain',...
'parameters are displayed.');

%VIEW DEFAULT VARIABLES--------------------------

elseif IMENU==3200
help_str=strvcat('TO VIEW DEFAULT VARIABLES',' ',...
'Displays current values of all',...
'parameters and control variables.');

%PID CONTROLLER COMPUTATION--------------------------

elseif IMENU==4250
help_str=strvcat('TO COMPUTE PID CONTROLLER',...
'PARAMETERS EQUIVALENT TO',...
'THE IMC CONTROLLER',' ',...
'Finds PID equivalent for given IMC',...
'controller. The results are shown',...
'in the command window. Also, they',...
'can be viewed using the PID',...
'controller Results option.',' ',...
'Shows setpoint step responses of',...
'all realizable PID, PI or I',...
'controllers and an IMC controller',...
'as shown in the title of the graphs.',' ',...
'Click the Change button to change',...
'the final time and step size.',' ',...
'Click any spot in the graph to see',...
'its coordinates.',' ',...
'A PID equivalent will be found only',...
'for a single-degree-of-freedom',...
'IMC controller in this version',...
'of the program.');

%UPPER BOUND OF FREQUENCY RESPONSES--------------------------

elseif IMENU==4300
help_str=strvcat('UPPER BOUND OF FREQUENCY',...
'RESPONSES',' ',...
'Computes an Upper bound of the',...
'frequency responses over the range of',...
'frequencies specified in the Default',...
'Variables Edit window for all',...
'possible processes.',...
'Shows the graph.',' ',...
'Click the Add button to add',...
'a frequency response of any plant.',...
'Enter the plant parameters inside',...
'the rectangular box of the Edit',...
'window. Click the OK button.',' ',...
'Click any spot in the graph to see',...
'its coordinates.');

%LOWER BOUND OF FREQUENCY RESPONSES--------------------------

elseif IMENU==4400
help_str=strvcat('LOWER BOUND OF FREQUENCY',...
'RESPONSES',' ',...
'Computes a Lower bound of the',...
'frequency responses over the range of',...
'frequencies specified in the Default',...
'Variables Edit window for all',...
'possible processes.',...
'Shows the graph.',' ',...
'Click the Add button to add',...
'a frequency response of any plant.',...
'Enter the plant parameters inside',...
'the rectangular box of the Edit',...
'window. Click the OK button.',' ',...
'Click any spot in the graph to see',...
'its coordinates.');

%UPPER & LOWER BOUND OF FREQUENCY RESPONSES--------------------------

elseif IMENU==4500
help_str=strvcat('UPPER & LOWER BOUND OF',...
'FREQUENCY RESPONSES',' ',...
'Computes both Upper & Lower bound of',...
'the frequency responses over the range of',...
'frequencies specified in the Default',...
'Variables Edit window for all',...
'possible processes.',...
'Shows the graph.',' ',...
'Click the Add button to add',...
'a frequency response of any plant.',...
'Enter the plant parameters inside',...
'the rectangular box of the Edit',...
'window. Click the OK button.',' ',...
'Click any spot in the graph to see',...
'its coordinates.');


end