function [pddenmt,pd_prime,pdxs]=pdmodel(Xpdnummt,Xpddenmt,vlb)
% function [pdnummt,pddenmt,pd_model,pds]=pdmodel(Xpdnummt,Xpddenmt,vlb)
% find the defult model of Pd for the qd calculation. It also claculate pds
% to be used in the partial sensitivity function for tuning of the
% disturbance rejection.
% Here, the model of Pd is a diagonal matrix containing the smallest lag on 
% each row of the original Pd process. Similarly, pds is a strig variable 
% that could be evaluated to have a representation of diagnoal Pd with uncertainty.

[m,n]=size(Xpddenmt);
pddenmt=cell(m,n);
pd_prime=pddenmt;
pd=pd_prime;
for i=1:m
   pddenmt{i,i}=mt2poly(Xpddenmt{i,1},vlb);
   index=1;
   for j=2:n
      temp=mt2poly(Xpddenmt{i,j},vlb);
      lentemp=length(temp);
      lenpdden=length(pddenmt{i,i});
      if lentemp >=2 & (temp(lentemp-1)/temp(lentemp) < ...
            pddenmt{i,i}(lenpdden-1)/pddenmt{i,i}(lenpdden))
         pddenmt{i,i}=temp;
         index=j;
      end
   end
   pd{i,i}=[mtx2str(Xpdnummt{i,index},1) '/' mtx2str(Xpddenmt{i,index},1)];
   pd_prime{i,i}=['1/' mtx2str(pddenmt{i,i},1)];
end
pdxs=cell2str(pd);
   